//=========================================================================
//	ff[^wb_[[ modeldata.cpp ]
//	쐬F2017/05/15
//	쐬ҁF
//=========================================================================
//=========================================================================
//	CN[ht@C
//=========================================================================
#include "modeldata.h"
#include "renderer.h"

//=========================================================================
//	RXgN^
//=========================================================================
CModelData::CModelData()
{
	m_pTextures = NULL;
	m_pMat = NULL;
	m_pMatBuffer = NULL;
	m_pMesh = NULL;
	m_nNumMat = 0;
}

//=========================================================================
//	f̓ǂݍ
//=========================================================================	
void	CModelData::Load( const char*  ModelName )
{
	LPDIRECT3DDEVICE9 pDevice;
	pDevice = CRenderer::GetDevice();
	
	HRESULT hr;			//   
	hr = D3DXLoadMeshFromX( ModelName , D3DXMESH_MANAGED , pDevice , NULL , &m_pMatBuffer , NULL , &m_nNumMat , &m_pMesh );
	if( FAILED( hr ) )
	{
		//s
		UINT nID = MessageBox( NULL , "bVf쐬ł܂\n" , "ERROR[ modeldata.cpp ]" , MB_OK | MB_ICONEXCLAMATION );
	}


	//}eÃ|C^Ƃăobt@̃AhX擾
	m_pMat = ( D3DXMATERIAL* )m_pMatBuffer->GetBufferPointer();
	m_pTextures	= new LPDIRECT3DTEXTURE9[m_nNumMat];

	for( DWORD i =0; i < m_nNumMat; i++ )
	{
		m_pTextures[ i ] = NULL;

		if( m_pMat[ i ].pTextureFilename )
		{
			char filePath[ MAX_PATH ];
			strcpy_s( filePath, TEXTURE_PATH );
			strcat_s( filePath, m_pMat[ i ].pTextureFilename );

			D3DXCreateTextureFromFile( pDevice, filePath, &m_pTextures[ i ] );
		}
	}
}

//=========================================================================
//	
//=========================================================================
void	CModelData::Unload( void )
{
	//[X
	if(m_pMesh != NULL)
	{
		m_pMesh->Release();	
		m_pMesh = NULL;		
	}

	//[X
	if(m_pMatBuffer != NULL)
	{
		m_pMatBuffer->Release();	
		m_pMatBuffer = NULL;	
	}

	for( DWORD i =0; i < m_nNumMat; i++ )
	{
		if(	m_pTextures[ i ] == NULL )
		{
			m_pTextures[ i ]->Release();
			m_pTextures[ i ] = NULL;
		}
	}
}
